"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = __importStar(require("ramda"));
var consts = __importStar(require("./consts"));
exports.isPrimary = R.propOr(false, 'primary');
exports.isGenerated = R.propOr(false, 'generated');
exports.isNullable = R.propOr(false, 'nullable');
exports.getType = function (type) {
    var types = {
        Int: 'int',
        Float: 'float',
        String: 'varchar'
    };
    return types[type] || 'unknown';
};
/** Get value for  whether column is nullable or not. */
exports.getNullable = function (obj) { return obj.directives[consts.COLUMN].nullable || obj.isNullable; };
exports.getColumn = function (obj) { return obj.directives[consts.COLUMN]; };
/** Convert a FieldSchema with Column Directive into TypeORM EntitySchemaColumnOptions Object */
exports.fromColumnField = function (obj) { return (__assign({}, exports.getColumn(obj), { type: obj.directives[consts.COLUMN].type || exports.getType(obj.type), nullable: exports.getNullable(obj) || undefined })); };
/** Convert a FieldSchema with PrimaryGeneratedColumn Directive into TypeORM EntitySchemaColumnOptions Object */
exports.fromPrimaryGeneratedField = function (obj) { return (__assign({}, obj.directives[consts.PRIMARY_GENERATED_COLUMN], { type: exports.getType(obj.type), primary: true, generated: true })); };
/** Convert a FieldSchema with PrimaryColumn Directive into TypeORM EntitySchemaColumnOptions Object */
exports.fromPrimaryField = function (obj) { return (__assign({}, obj.directives[consts.PRIMARY_COLUMN], { type: exports.getType(obj.type), primary: true })); };
exports.fromCreateDateField = function (obj) { return (__assign({}, obj.directives[consts.CREATE_DATE_COLUMN], { type: obj.directives[consts.CREATE_DATE_COLUMN].type || 'timestamp with time zone', createDate: true })); };
exports.fromUpdateDateField = function (obj) { return (__assign({}, obj.directives[consts.UPDATE_DATE_COLUMN], { type: obj.directives[consts.UPDATE_DATE_COLUMN].type || 'timestamp with time zone', updateDate: true })); };
/** Convert a FieldSchema into a TypeORM EntitySchemaColumnOptions Object. */
exports.fromField = R.cond([
    [R.pipe(R.prop('directives'), R.has(consts.COLUMN)), exports.fromColumnField],
    [R.pipe(R.prop('directives'), R.has(consts.PRIMARY_GENERATED_COLUMN)), exports.fromPrimaryGeneratedField],
    [R.pipe(R.prop('directives'), R.has(consts.CREATE_DATE_COLUMN)), exports.fromCreateDateField],
    [R.pipe(R.prop('directives'), R.has(consts.UPDATE_DATE_COLUMN)), exports.fromUpdateDateField],
    [R.T, exports.fromPrimaryField]
]);
exports.fromColumnsObject = R.mapObjIndexed(function (column, name) { return exports.fromField(column); });
exports.getColumns = R.pipe(R.prop('fields'), R.pickBy(R.where({
    directives: R.anyPass([
        R.has(consts.COLUMN),
        R.has(consts.PRIMARY_GENERATED_COLUMN),
        R.has(consts.PRIMARY_COLUMN),
        R.has(consts.CREATE_DATE_COLUMN),
        R.has(consts.UPDATE_DATE_COLUMN)
    ])
})));
exports.fromTypes = R.pipe(exports.getColumns, exports.fromColumnsObject);
