"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var column_1 = require("./column");
var relation_1 = require("./relation");
var consts_1 = require("./consts");
var R = __importStar(require("ramda"));
exports.fromObject = R.applySpec({
    name: R.prop('name'),
    columns: column_1.fromTypes,
    relations: relation_1.fromTypes
});
exports.fromEntitiesObject = R.mapObjIndexed(function (entity, name) { return exports.fromObject(R.assoc('name', name, entity)); });
exports.getEntities = R.pickBy(R.where({ directives: R.has(consts_1.ENTITY) }));
exports.fromTypes = R.pipe(exports.getEntities, exports.fromEntitiesObject);
