"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = __importStar(require("ramda"));
var typeorm_1 = require("typeorm");
exports.createWhere = function (query) {
    return R.mapObjIndexed(function (value, key) {
        if (R.has('$eq')) {
            return typeorm_1.Equal(value.$eq);
        }
        else if (R.has('$gt')) {
            return typeorm_1.MoreThan(value.$gt);
        }
        else if (R.has('$gte')) {
            return typeorm_1.MoreThanOrEqual(value.$gte);
        }
        else if (R.has('$in')) {
            return typeorm_1.Any(value.$in);
        }
        else if (R.has('$lt')) {
            return typeorm_1.LessThan(value.$lt);
        }
        else if (R.has('$lte')) {
            return typeorm_1.LessThanOrEqual(value.$lte);
        }
        else if (R.has('$ne')) {
            return typeorm_1.Not(typeorm_1.Equal(value.$ne));
        }
        else if (R.has('$nin')) {
            return typeorm_1.Not(typeorm_1.Any(value.$nin));
        }
        return typeorm_1.Equal(value);
    }, query.where);
};
exports.createOrder = function (query) { return query.order || {}; };
exports.createQuery = R.applySpec({
    where: exports.createWhere,
    order: exports.createOrder,
    skip: R.propOr(0, 'skip'),
    take: R.propOr(1E100, 'take')
});
