"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = __importStar(require("ramda"));
var consts_1 = require("../consts");
exports.getType = function (type) { return consts_1.typeOrmToTs[type] || ''; };
exports.getRelationshipType = function (relationship) {
    return "" + relationship.target + (relationship.type === 'one-to-many' || relationship.type === 'many-to-many' ? '[]' : '');
};
exports.relationshipToTypeField = function (relationship, name) {
    return "" + name + (relationship.nullable ? '?' : '') + ": " + exports.getRelationshipType(relationship);
};
exports.columnToTypeField = function (column, name) {
    return "" + name + (column.nullable ? '?' : '') + ": " + exports.getType(column.type) + ";";
};
exports.default = (function (entitySchema) { return "export interface " + entitySchema.name + " {\n    " + R.pipe(R.mapObjIndexed(exports.columnToTypeField), R.values, R.join('\n\t'))(entitySchema.columns) + "\n    " + R.pipe(R.mapObjIndexed(exports.relationshipToTypeField), R.values, R.join('\n\t'))(entitySchema.relations) + "\n}\n"; });
