"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = __importStar(require("ramda"));
var column_1 = require("../column");
exports.getGraphQLType = function (type) {
    var types = {
        string: 'String',
        int: 'Int',
        float: 'Float',
        varchar: 'String'
    };
    return types[type] || types['string'];
};
exports.toGraphQLUpdate = function (entitySchema) { return "\ninput " + entitySchema.name + "Update {\n    " + R.pipe(R.pickBy(function (entitySchema, name) { return !column_1.isGenerated(entitySchema); }), R.mapObjIndexed(function (column, name) { return name + ": " + exports.getGraphQLType(column.type.toString()); }), R.values, R.join('\n\t'))(entitySchema.columns) + "\n}\n"; };
exports.toGraphQLCreate = function (entitySchema) { return "\ninput " + entitySchema.name + "Create {\n    " + R.pipe(R.pickBy(function (entitySchema, name) { return !column_1.isGenerated(entitySchema); }), R.mapObjIndexed(function (column, name) { return name + ": " + exports.getGraphQLType(column.type.toString()) + (!column_1.isNullable(column) ? '!' : ''); }), R.values, R.join('\n\t'))(entitySchema.columns) + "\n}\n"; };
exports.toGraphQLMutations = function (entitySchema) {
    return [
        "create" + entitySchema.name + "(data: " + entitySchema.name + "Create): " + entitySchema.name,
        "update" + entitySchema.name + "(data: " + entitySchema.name + "Update): " + entitySchema.name,
        "delete" + entitySchema.name + "(data: ID): ID"
    ].join('\n\t');
};
exports.toGraphQL = function (types) { return "\n" + R.pipe(R.mapObjIndexed(function (entitySchema, name) { return [
    exports.toGraphQLCreate(entitySchema),
    exports.toGraphQLUpdate(entitySchema),
]; }), R.mapObjIndexed(function (inputTypes) { return inputTypes.join('\n\t'); }), R.values, R.join('\n'))(types) + "\n\ntype Mutation {\n    " + R.pipe(R.mapObjIndexed(function (entitySchema, name) {
    return exports.toGraphQLMutations(entitySchema);
}), R.values, R.join('\n\n\t'))(types) + "\n}\n"; };
