"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var resolvers_1 = require("./resolvers");
var R = __importStar(require("ramda"));
exports.getColumnType = function (column) {
    var types = {
        string: 'FieldQueryString',
        int: 'FieldQueryNumber'
    };
    return types[column.type.toString()] || types.string;
};
exports.columnToGraphQL = function (column, name) {
    return name + ": " + exports.getColumnType(column);
};
exports.toGraphQLWhere = function (entitySchema) { return "\ntype " + entitySchema.name + "Where {\n    " + R.pipe(R.mapObjIndexed(function (column, name) { return exports.columnToGraphQL(column, name); }), R.values, R.join('\n\t'))(entitySchema.columns || {}) + "\n}\n"; };
exports.toGraphQLOrder = function (entitySchema) { return "\ntype Order {\n    name: String!\n    id: String!\n}"; };
exports.toGraphQLQuery = function (entitySchema) { return "\ninput " + entitySchema.name + "Query {\n    where: " + entitySchema.name + "Where\n    take: number\n    skip: number\n    order: Order\n}\n"; };
exports.toGraphQLQueries = function (entitySchema) {
    return [
        resolvers_1.lowerFirst(entitySchema.name) + "(id: Int): " + entitySchema.name,
        resolvers_1.lowerFirst(entitySchema.name) + "s(data: " + entitySchema.name + "Query): [" + entitySchema.name + "]"
    ].join('\n\t');
};
exports.toGraphQL = function (types) { return "\ntype Order {\n    name: String!\n    id: String!\n}\n\n" + R.pipe(R.mapObjIndexed(function (entitySchema, name) { return [
    exports.toGraphQLWhere(entitySchema),
    exports.toGraphQLQuery(entitySchema),
]; }), R.mapObjIndexed(function (inputTypes) { return inputTypes.join('\n\t'); }), R.values, R.join('\n'))(types) + "\n\ntype Query {\n    " + R.pipe(R.mapObjIndexed(function (entitySchema, name) {
    return exports.toGraphQLQueries(entitySchema);
}), R.values, R.join('\n\n\t'))(types) + "\n}\n"; };
