"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = __importStar(require("ramda"));
var interface_1 = __importDefault(require("./interface"));
var findOneType_1 = __importDefault(require("./findOneType"));
var createUpdateType_1 = __importDefault(require("./createUpdateType"));
var resolverTypes_1 = __importDefault(require("./resolverTypes"));
exports.default = (function (types, contextPath) {
    if (contextPath === void 0) { contextPath = './context'; }
    return R.pipe(R.mapObjIndexed(function (entity, name) { return [
        interface_1.default(entity),
        findOneType_1.default(entity),
        createUpdateType_1.default(entity),
        resolverTypes_1.default(entity.name),
    ]; }), R.mapObjIndexed(R.join('\n\n')), R.values, R.join('\n'), R.concat('export type ResolverFunction<S,T,U,V> = (parent: S, args: T, context: U) => V\n\n'), R.concat("import { Context } from '" + contextPath + "'\n\n"), R.concat("import { QueryArgs } from 'graphql_typeorm/dist/query'\n"))(types);
});
